/* Determine if screen can handle touch events. */
if ( ! ( ( 'ontouchstart' in window ) || ( navigator.maxTouchPoints > 0 ) || ( navigator.msMaxTouchPoints > 0 ) ) ) {
	jQuery( 'html' ).addClass( 'no-touch' );
}

jQuery( function( $ ) { 'use strict';

	/* Handle collapsable inputs */
	$( '#theme-additional-fields #featured_area_type' ).on( 'change', function( e ) {
		var featured_type = $( this ).val();
		var $slider_container = jQuery( '#theme-additional-fields .katerina-metabox-field-slider' );
		var $slider_displacement_settings = jQuery( '#theme-additional-fields .katerina-displacement-tweaks' );
		var $custom_html = getFieldContainer( '#custom_featured_area_html' );
		var $contacts_container = getFieldContainer( '#featured_general_text' );
		var $caption_container = getFieldContainer( '#featured_area_text' );
		var $overlay_container = getFieldContainer( '#featured_area_no_overlay' );
		var $no_social_container = getFieldContainer( '#featured_area_no_social' );
		var $no_scroll_content = getFieldContainer( '#featured_area_no_scroll_content' );
		if ( 'slider' === featured_type ) {
			$slider_container.show();
		} else {
			$slider_container.hide();
		}
		if ( 'video' === featured_type || 'html' === featured_type ) {
			$custom_html.show();
		} else {
			$custom_html.hide();
		}
		if ( '' !== featured_type ) {
			$contacts_container.show();
		} else {
			$contacts_container.hide();
		}
		if ( 'slider' === featured_type ) {
			$slider_displacement_settings.show();
		} else {
			$slider_displacement_settings.hide();
		}
		if ( '' !== featured_type && 'slider' !== featured_type ) {
			$caption_container.show();
		} else {
			$caption_container.hide();
		}
		if ( '' !== featured_type ) {
			$overlay_container.show();
			$no_social_container.show();
			$no_scroll_content.show();
		} else {
			$overlay_container.hide();
			$no_social_container.hide();
			$no_scroll_content.hide();
		}
	});

	/* Handle collapsable inputs */
	$( '#theme-additional-fields #slider_automatic' ).on( 'change', function( e ) {
		var $details = jQuery( '#theme-additional-fields .slider_automatic_details' );
		if ( $( this ).is( ':checked' ) ) {
			$details.show();
		} else {
			$details.hide();
		}
	});

	$( '#theme-additional-fields #content_style' ).on( 'change', function( e ) {
		var content_type   = $( this ).val();
		var $title_tagline = getFieldContainer( '#title_tagline' );
		var page_sidebar   = getFieldContainer( '#page_sidebar' );
		if ( '' !== content_type ) {
			$title_tagline.hide();
		} else {
			$title_tagline.show();
		}
		if ( 'hide' === content_type ) {
			page_sidebar.hide();
		} else {
			page_sidebar.show();
		}
	});

	$( '#theme-additional-fields .katerina-metabox-field-slider .add-new-popup > .button' ).on ( 'click', function( e ) {
		var $parent = $( this ).parents( '.katerina-metabox-input' ), $template = $parent.find( '.template.' + $( this ).data( 'type' ) ).clone().removeClass( 'template' ).css({
			'opacity' : 0
		});
		$( 'input, textarea', $template ).prop( 'disabled', false );
		$( '.slider-content', $parent ).append( $template );
		$template.animate({
			'opacity' : 1
		}, 200, function() {
			$( this ).attr( 'style', '' );
		});
		e.preventDefault();
	});

	$( document ).on( 'click', '#theme-additional-fields .slider-content .remove-item', function( e ) {
		$( this ).parents( '.slider-item' ).animate({
			'height'      : 0,
			'margin-bottom': 0,
			'opacity'      : 0
		}, 200, function() {
			var $container = $( this ).parents( '.slider-content' );
			$( this ).remove();
		});
		e.preventDefault();
	});

	/* Handle uploading and reordering project additional images */
	var media_frame, $slider_item;
	$( document ).on( 'click', '#theme-additional-fields .katerina-metabox-field-slider .select-image', function( e ) {
		e.preventDefault();

		$slider_item = $( this ).parents( '.slider-item' );
		if ( ! media_frame ) {
			media_frame = wp.media( {
				className: 'media-frame katerina-media-frame',
				title    : $( this ).data( 'frame-title' ),
				library  : { type: 'image' }
			} );

			media_frame.on( 'select', function() {
				var selection = media_frame.state().get( 'selection' ).toJSON()[0];
				$( '.image-wrap img', $slider_item ).attr({
					'src'    : selection.sizes.thumbnail.url,
					'width'  : selection.sizes.thumbnail.width,
					'height' : selection.sizes.thumbnail.height,
					'alt'    : selection.alt,
					'data-id': selection.id
				});
				$( '.image-wrap input', $slider_item ).val( selection.id );
				$( '.select-image', $slider_item ).addClass( 'has-image' );
			} );
		}

		media_frame.open();
	} );

	$('#theme-additional-fields .slider-content').each( function() {
		var $this = $( this );
		$this.sortable( {
			items                : '.slider-item',
			handle               : '.title',
			placeholder          : 'placeholder',
			forcePlaceholderSize : true
		} );
	} );

	/* Handle uploading and reordering additional images */
	var media_frame_additional;
	jQuery( document ).on( 'click', '#theme-additional-fields .katerina-metabox-field-images .add-images', function( e ) {
		e.preventDefault();

		var $imageList = jQuery( this ).siblings( '.katerina-images' ), $uploadButton = jQuery( this );
		if ( ! media_frame_additional ) {
			media_frame_additional = wp.media( {
				className: 'media-frame katerina-media-frame',
				multiple : true,
				title    : $uploadButton.data( 'frame-title' ),
				library  : { type: 'image' }
			} );

			media_frame_additional.on( 'select', function() {
				var selection = media_frame_additional.state().get( 'selection' ).toJSON(),
					current_ids = jQuery( '#theme-additional-fields #' + $imageList.data( 'field-id' ) ).val();
				jQuery( selection ).each(function() {
					if ( jQuery( 'li#image_item_' + this.id, $imageList ).length === 0 ) {
						$imageList.append( '<li id="image_item_' + this.id + '"><img src="' + this.sizes.thumbnail.url + '" width="' + this.sizes.thumbnail.width + '" height="' + this.sizes.thumbnail.height + '"><a title="' + $imageList.data( 'edit-title' ) + '" class="katerina-edit-image" href="' + this.editLink + '" target="_blank">' + $imageList.data( 'edit-text' ) + '</a><a title="' + $imageList.data( 'remove-title' ) + '" class="katerina-delete-image" href="#"></a></li>' );
						if ( current_ids.length > 0) {
							current_ids = ( current_ids + ',' + this.id );
						} else {
							current_ids = ( this.id + '' );
						}
					}
				});
				jQuery( '#theme-additional-fields #' + $imageList.data( 'field-id' ) ).val( current_ids );
				$imageList.trigger( 'update.katerina' );
			} );
		}

		media_frame_additional.open();
	} );

	jQuery( '.katerina-images' ).each( function() {
		var $this = jQuery( this );
		$this.sortable( {
			placeholder : 'ui-state-highlight',
			items       : 'li',
			update      : function() {
				updateImageIds( $this );
			}
		} );
	} );

	jQuery( document ).on( 'click', '#theme-additional-fields .katerina-images .katerina-delete-image', function( e ) {
		e.preventDefault();

		var $parent = jQuery( this ).parent( 'li' ),
			$container = $parent.parent();

		$parent.animate({
			width       : 0,
			marginRight : 0,
			opacity     : 0
		}, 300, function() {
			jQuery( this ).remove();
			$container.trigger( 'update.katerina' );
			updateImageIds( $container );
		});

	} );

	function updateImageIds( $list ) {
		var idList = $list.sortable( 'serialize' );
		idList = idList.replace( /(&)image_item\[\]=/g, ',' );
		idList = idList.replace( /image_item\[\]=/g, '' );
		jQuery( '#theme-additional-fields #' + $list.data( 'field-id' ) ).val( idList );
	}

	function getFieldContainer( field ) {
		return jQuery( field, '#theme-additional-fields' ).parents( '.katerina-metabox-field' );
	}


	/* Handle uploading image files */
	var media_frame_image;
	$( document ).on( 'click', '#theme-additional-fields .set-image', function( e ) {
		e.preventDefault();

		var $uploadButton = $( this ), $input_parent = $uploadButton.closest( '.katerina-metabox-input' );
		if ( ! media_frame_image ) {
			media_frame_image = wp.media( {
				title    : $uploadButton.data( 'frame-title' ),
				library  : { type: 'image' },
				multiple : false
			} );

			media_frame_image.on( 'select', function() {
				var attachment = media_frame_image.state().get( 'selection' ).first().toJSON();
				$input_parent.find( 'input.image_url' ).val( attachment.url );
			} );
		}

		media_frame_image.open();
	} );

} );
