<?php
/**
 * Handle metabox options.
 */

function katerina_helper_additional_page_meta_box_options() {

	if ( apply_filters( 'theme_additional_page_meta_box_options_restrict_template', true ) ) {
		return;
	}

	$theme_options_callback = apply_filters( 'theme_additional_page_meta_box_options_callback', false );
	if ( $theme_options_callback ) {
		add_meta_box(
			'theme-additional-fields',
			esc_html__( 'Additional Page Options', 'katerina-helper' ),
			$theme_options_callback,
			apply_filters( 'theme_additional_page_meta_box_options_post_types', array( 'page', 'post', 'project', 'product' ) ),
			'normal'
		);
	}

	$theme_options_instructions = apply_filters( 'theme_additional_page_meta_box_options_instructions', false );
	if ( $theme_options_instructions ) {
		get_current_screen()->add_help_tab( array(
			'id'       => 'theme-additional-fields',
			'title'    => esc_html__( 'Additional Options', 'katerina-helper' ),
			'content'  => $theme_options_instructions,
			'priority' => 70,
		) );
	}

}
add_action( 'add_meta_boxes', 'katerina_helper_additional_page_meta_box_options', 10, 1 );

/**
 * Add theme metabox scripts and style.
 */
function katerina_helper_metabox_admin_enqueue_scripts() {

	if ( 'post' !== get_current_screen()->base ) {
		return;
	}

	wp_enqueue_media();
	wp_enqueue_style( 'katerina-helper-metabox-fields', KATERINA_HELPER_PLUGIN_URL . '/assets/css/metabox-fields.css', null, false );
	wp_enqueue_script( 'katerina-helper-metabox-fields', KATERINA_HELPER_PLUGIN_URL . '/assets/js/metabox-fields.js', null, false, true );
}
add_action( 'admin_enqueue_scripts', 'katerina_helper_metabox_admin_enqueue_scripts' );
