<?php
/**
 * Plugin Name: Katerina Helper
 * Plugin URI: http://themeforest.net/user/liviu_cerchez
 * Description: Helper plugin for the Katerina theme (optional)
 * Version: 1.0
 * Author: liviu_cerchez
 * Author URI: http://themeforest.net/user/liviu_cerchez
 * Requires at least: 5.9
 * Tested up to: 6.1

 * Text Domain: katerina-helper
 * Domain Path: /languages/

 * @package Katerina Helper
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! defined( 'KATERINA_HELPER_PLUGIN_URL' ) ) {
	define( 'KATERINA_HELPER_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
}
if ( ! defined( 'KATERINA_HELPER_PLUGIN_PATH' ) ) {
	define( 'KATERINA_HELPER_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );
}

/**
 * Load all translations for our plugin from the MO file.
 */
function katerina__helperload_textdomain() {
	load_plugin_textdomain( 'katerina-helper', false, basename( __DIR__ ) . '/languages' );
}
add_action( 'init', 'katerina__helperload_textdomain' );

if ( is_admin() ) {
	require_once 'includes/metabox-options.php';
	require_once 'includes/demo-importer/class-katerina-demo-data-import.php';
}

// Allow iframes and video tags only in the featured area (the safe way, no hacks)
function katerina_wp_kses_allowed_html( $allowed_tags, $context ) {
	if ( 'katerina-featured' === $context ) {
		$allowed_tags['iframe'] = array(
			'width' => true,
			'height' => true,
			'src' => true,
			'id' => true,
			'class' => true,
			'frameborder' => true,
			'style' => true,
			'allow' => true,
		);
		$allowed_tags['video'] = array(
			'width' => true,
			'height' => true,
			'src' => true,
			'id' => true,
			'class' => true,
			'poster' => true,
			'preload' => true,
			'autoplay' => true,
			'loop' => true,
			'muted' => true,
		);
	}
	return $allowed_tags;
}
add_filter( 'wp_kses_allowed_html', 'katerina_wp_kses_allowed_html', 10, 2 );

/* Add blocks for Gutenberg editor */
require( KATERINA_HELPER_PLUGIN_PATH . 'blocks/gallery.php' );
